// This is actually original.. but it's just the driver and display for three
// types of passwords that get generated.
// Nick Vrtis - nick@vrtisworks.com


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.Random;
import java.net.URL;

public class PasswordMaker extends Applet {
	boolean isStandalone = false;
	GridBagLayout gridBagLayout1 = new GridBagLayout();
	Label jLabel1 = new Label();
	Choice minSizeBox = new Choice();
	Label jLabel2 = new Label();
	Choice maxSizeBox = new Choice();
	Checkbox numbersBox = new Checkbox();
	Button generateIt = new Button();
	TextArea passwordList = new TextArea("",12,30,TextArea.SCROLLBARS_NONE);
  TextArea passwordPhrase = new TextArea("",13,28,TextArea.SCROLLBARS_NONE);
  private final int MINPW = 5;
  private final int MAXPW = 12;				//Max allowed
  private int minPWSize = 7;					//Minimum number of characters in PW
  private int maxPWSize = 10;					//Maximum number of characters in PW
  private Pronouncable type1;
  private WordBox type2;
  private PasswordPhrase type3;
  private Random randomGenerator = new Random();
  private char [] fromChars = {'E','I','O','G','S','Z','P'};
  private char [] toDigits = {'3','1','0','6','8','2','9'};
	private GridBagConstraints gridBagConstraints = new GridBagConstraints();
  private Frame theFrame;
  private static final String BGCOLOR = "FFCCCC";
  private static final String FGCOLOR = "0000FF";
  private Color bgColor;
  private Color fgColor;

//Get a parameter value

	public String getParameter(String key, String def) {
		return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
	}

	//Construct the applet

	public PasswordMaker() {
	}
//Initialize the applet

	public void init() {
  	bgColor = this.getColorParameter("bgcolor",BGCOLOR);
    fgColor = this.getColorParameter("fgcolor",FGCOLOR);
    if (!isStandalone) {
    	// Hack from Symantec BBS to get Frame of an applet
			Container aParent = this.getParent();
      while (!(aParent instanceof Frame)) {
	     	aParent = aParent.getParent();
      }
      theFrame = (Frame) aParent;
			theFrame.setTitle(getAppletInfo());
		}
		theFrame.setBackground(bgColor);
    theFrame.setForeground(fgColor);
		try {
		jbInit();
		}
		catch (Exception e) {
		e.printStackTrace();
		}
    //Fill drop down box with lengths available
    for (int x=MINPW; x<=MAXPW; x++) {
			minSizeBox.addItem(Integer.toString(x));
      maxSizeBox.addItem(Integer.toString(x));
    }
		//Force initial select to defaults
    minSizeBox.select(Integer.toString(minPWSize));
    maxSizeBox.select(Integer.toString(maxPWSize));
    numbersBox.setState(true);
    type1 = new Pronouncable();
    type2 = new WordBox(this.getCodeBase());
    type3 = new PasswordPhrase(passwordPhrase);
    generateThem();					//Give the first set with the defaults
	}
//Component initialization

	private void jbInit() throws Exception {
		jLabel1.setText("Minimum");
		jLabel2.setText("Maximum");
		numbersBox.setLabel("Use Digits");
		generateIt.setLabel("Generate");
    generateIt.setBackground(bgColor);
    generateIt.setForeground(fgColor);
		generateIt.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				generateIt_actionPerformed(e);
			}
		});
		passwordList.setFont(new Font("Monospaced", 0, 12));
    passwordList.setEditable(false);
		passwordPhrase.setFont(new Font("Monospaced", 0, 12));
    passwordPhrase.setEditable(false);
    minSizeBox.setBackground(bgColor);
    minSizeBox.setForeground(fgColor);
    maxSizeBox.setBackground(bgColor);
    maxSizeBox.setForeground(fgColor);
		this.setLayout(gridBagLayout1);
    this.setSize(600,300);
    this.add(passwordPhrase, setGridBagConstraints(0, 0, 4, 6, 0.0, 1.0
    				,GridBagConstraints.CENTER,GridBagConstraints.BOTH, new Insets(10,20,10,10),0,0));
		this.add(jLabel1,        setGridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 20, 0, 0), 0, 0));
		this.add(minSizeBox,     setGridBagConstraints(1, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.add(jLabel2,        setGridBagConstraints(2, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 60, 0, 0), 0, 0));
		this.add(maxSizeBox,     setGridBagConstraints(3, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 10), 0, 0));
		this.add(generateIt,     setGridBagConstraints(0, 8, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(10, 20, 10, 0), 0, 0));
		this.add(numbersBox,     setGridBagConstraints(2, 8, 2, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
		this.add(passwordList,   setGridBagConstraints(4, 0, 4, 9, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 10, 10, 20), 0, 0));
	}
//Start the applet

	public void start() {
	}
//Stop the applet

	public void stop() {
	}
//Destroy the applet

	public void destroy() {
	}
//Get Applet information

	public String getAppletInfo() {
		return "Password Generator V1.2 - Nick Vrtis 2001";
	}
//Get parameter info

	public String[][] getParameterInfo() {
    String [] [] info = {
    {"bgcolor", "hexadecimal color value", "background color"},
    {"fgcolor", "hexadecimal color value", "foreground color"}
    };
		return info;
	}

  private Color getColorParameter(String pname, String dflt) {
    String value = this.getParameter(pname,dflt);
    try { return new Color(Integer.parseInt(value, 16)); }
    catch (Exception e) {
    	if (pname.equals("bgcolor"))
     		return Color.lightGray;
      else
      	return Color.black;
    }
  }

  private int getRandomInt(int x) {
  	int z = randomGenerator.nextInt();
    if (z<0) z=-z;
    return z%x;
  }
  private GridBagConstraints setGridBagConstraints (
  	int gridX, int gridY,
    int gridW, int gridH,
    double weightX, double weightY,
    int anchor, int fill,
    Insets insets,
    int ipadX, int ipadY) {
    	gridBagConstraints.gridx=gridX;
      gridBagConstraints.gridy=gridY;
      gridBagConstraints.gridwidth=gridW;
      gridBagConstraints.gridheight=gridH;
      gridBagConstraints.weightx=weightX;
      gridBagConstraints.weighty=weightY;
      gridBagConstraints.anchor=anchor;
      gridBagConstraints.fill=fill;
      gridBagConstraints.insets=insets;
      gridBagConstraints.ipadx=ipadX;
      gridBagConstraints.ipady=ipadY;
			return gridBagConstraints;
    }

	void generateIt_actionPerformed(ActionEvent e) {
  	generateThem();
  }

  private void generateThem() {
  	int x;
    int s;
		String thePW;

    passwordList.setText("");		//Get rid of any from last time

    //Get min/max sizes requested
    minPWSize = minSizeBox.getSelectedIndex()+MINPW;
    maxPWSize = maxSizeBox.getSelectedIndex()+MINPW;
    if (maxPWSize<minPWSize)	//Make sure MAX >= MIN
    	maxPWSize=minPWSize;

    for (x=0; x<9; x++) {				//9 from WordBox
    	if (minPWSize!=maxPWSize)
      	s=getRandomInt(maxPWSize-minPWSize)+minPWSize;
      else
      	s=minPWSize;
			thePW=type2.generate(s);
		  passwordList.append(digitize(thePW));
    }
    for (x=0; x<9; x++) {				//9 from Pronouncable
    	if (minPWSize!=maxPWSize)
      	s=getRandomInt(maxPWSize-minPWSize)+minPWSize;
      else
      	s=minPWSize;
    	thePW=type1.generate(s);
		  passwordList.append(digitize(thePW));
    }
    if (minPWSize!=maxPWSize)	//only 1 from phrase generator
    	s=getRandomInt(maxPWSize-minPWSize)+minPWSize;
    else
    	s=minPWSize;
    thePW=type3.generate(s);
    passwordPhrase.append(digitize(thePW));
	}
  private String digitize(String pw) {
    char [] digitWork;
    char [] pwChars;
    boolean useDigits;
    int c;
    int i;

    useDigits = numbersBox.getState();

    if (useDigits) {											//See if wants to substitute digits
    	digitWork = new char[maxPWSize+1];	//Allocate max digits+trailing space
      for (c=0; c<digitWork.length; c++)	//Clear to spaces.
      	digitWork[c]=' ';
     	pwChars = pw.toCharArray();
      System.arraycopy(pwChars,0,digitWork,0,pwChars.length);
      for (c=0; c<fromChars.length; c++) {
      	i=pw.indexOf(fromChars[c],1);	//Don't change 1st char to digit
        while (i!=-1) {
        	digitWork[i]=toDigits[c];
          i++;														//Skip digit just found
         	i=pw.indexOf(fromChars[c],i);		//Try to find more
        }
      }

      pw = new String(digitWork)+"["+pw+"]";
    }
    return "\n"+pw;
  }
}
