// Not sure where I got most of the ideas for this.. probably some other
// password generator.  Modified it a lot from there.
// Nick Vrtis - nick@vrtisworks.com

import java.util.Vector;
import java.util.Random;

public class Pronouncable extends Object {
  private Vector vowels = new Vector();
  private Vector consonants = new Vector();
  private final int VOWELSHORT = 1;
  private final int VOWELLONG = 2;
  private final int VOWELOTHER = 3;
  private final int CONSONANT = 100;
  private PasswordEntry prevPWE;
  private int vowelCnt;
  private Random randomGenerator = new Random();

	public Pronouncable() {
  
    vowels.addElement(new PasswordEntry("a",VOWELSHORT,new String [] {"A"}));
    vowels.addElement(new PasswordEntry("A",VOWELLONG,new String [] {"A","AE","AI"}));
    vowels.addElement(new PasswordEntry("e",VOWELSHORT,new String [] {"E"}));
    vowels.addElement(new PasswordEntry("E",VOWELSHORT,new String [] {"E","EE","IE"}));
    vowels.addElement(new PasswordEntry("i",VOWELSHORT,new String [] {"I","E"}));
    vowels.addElement(new PasswordEntry("I",VOWELLONG,new String [] {"I","AI"}));
    vowels.addElement(new PasswordEntry("i'",VOWELOTHER,new String [] {"I","EI"}));
    vowels.addElement(new PasswordEntry("o",VOWELSHORT,new String [] {"O","A","AH"}));
    vowels.addElement(new PasswordEntry("O",VOWELLONG,new String [] {"O","OH"}));
    vowels.addElement(new PasswordEntry("oo",VOWELSHORT,new String [] {"OO","U"}));
    vowels.addElement(new PasswordEntry("OO",VOWELLONG,new String [] {"OO","WO"}));
    vowels.addElement(new PasswordEntry("u",VOWELSHORT,new String [] {"U"}));
    vowels.addElement(new PasswordEntry("U",VOWELLONG,new String [] {"U","OO"}));
    vowels.addElement(new PasswordEntry("y",VOWELLONG,new String [] {"Y"}));
		consonants.addElement(new PasswordEntry("b",CONSONANT,new String [] {"B"}));
		consonants.addElement(new PasswordEntry("ch",CONSONANT,new String [] {"CH"}));
		consonants.addElement(new PasswordEntry("d",CONSONANT,new String [] {"D"}));
		consonants.addElement(new PasswordEntry("f",CONSONANT,new String [] {"F","PH","GH"}));
		consonants.addElement(new PasswordEntry("g",CONSONANT,new String [] {"G"}));
		consonants.addElement(new PasswordEntry("h",CONSONANT,new String [] {"H"}));
		consonants.addElement(new PasswordEntry("j",CONSONANT,new String [] {"J","G"}));
		consonants.addElement(new PasswordEntry("k",CONSONANT,new String [] {"K","C"}));
		consonants.addElement(new PasswordEntry("l",CONSONANT,new String [] {"L"}));
		consonants.addElement(new PasswordEntry("m",CONSONANT,new String [] {"M"}));
		consonants.addElement(new PasswordEntry("n",CONSONANT,new String [] {"N"}));
		consonants.addElement(new PasswordEntry("ng",CONSONANT,new String [] {"NG"}));
		consonants.addElement(new PasswordEntry("p",CONSONANT,new String [] {"P"}));
		consonants.addElement(new PasswordEntry("qu",CONSONANT,new String [] {"QU"}));
		consonants.addElement(new PasswordEntry("r",CONSONANT,new String [] {"R"}));
		consonants.addElement(new PasswordEntry("s",CONSONANT,new String [] {"S","C"}));
		consonants.addElement(new PasswordEntry("t",CONSONANT,new String [] {"T"}));
		consonants.addElement(new PasswordEntry("th",CONSONANT,new String [] {"TH"}));
		consonants.addElement(new PasswordEntry("v",CONSONANT,new String [] {"V"}));
		consonants.addElement(new PasswordEntry("x",CONSONANT,new String [] {"X"}));
		consonants.addElement(new PasswordEntry("y",CONSONANT,new String [] {"Y"}));
		consonants.addElement(new PasswordEntry("z",CONSONANT,new String [] {"Z","S"}));
	}

	public String generate(int targetSize) {

    String pw = "";
    String pwg = "";
    prevPWE=null;					//Nothing previous
    PasswordEntry pwe;		//This will be the returned entry
    //NOTE:  Password might not be exactly targetSize, might be +1 char, never
    //			 larger than maxPWSize
    while (pw.length()<targetSize) {
    	prevPWE = getNextPWE();
      pw = pw+prevPWE.getLetters(getRandomInt(prevPWE.getLettersCount()));
      pwg = pwg+prevPWE.getGraph();
      //System.out.println("PW="+pw+"<:>"+pwg);
    }
    return pw;
	}

  private PasswordEntry getNextPWE() {
  	if (prevPWE==null) {						//See if first time through
      if (getRandomInt(2)==0) {			//Pick whether 1st is vowel or consonent
      	vowelCnt=1;
      	return (PasswordEntry)vowels.elementAt(getRandomInt(vowels.size()));
      }
      else {
      	vowelCnt=0;									//Reset vowelCnt
      	return (PasswordEntry)consonants.elementAt(getRandomInt(consonants.size()));
      }
    }
    if (vowelCnt>1) {							//Only 2 vowels in a row before consonant
     	vowelCnt=0;									//Reset vowelCnt
     	return (PasswordEntry)consonants.elementAt(getRandomInt(consonants.size()));
    }
    if (prevPWE.getType()==CONSONANT) {	//Consonant must be followed by a vowel
     	vowelCnt=1;
     	return (PasswordEntry)vowels.elementAt(getRandomInt(vowels.size()));
    }
    if (getRandomInt(10)>7)	{			//Most of time return consonant after vowel
     	vowelCnt++;									//Sometimes can return another vowel
      PasswordEntry pwe = (PasswordEntry)vowels.elementAt(getRandomInt(vowels.size()));
      while (pwe.getType() != prevPWE.getType())
				pwe = (PasswordEntry)vowels.elementAt(getRandomInt(vowels.size()));
     	return pwe;
    }
    else {
     	vowelCnt=0;									//Reset vowelCnt
     	return (PasswordEntry)consonants.elementAt(getRandomInt(consonants.size()));
    }
  }

  private int getRandomInt(int x) {
  	int z = randomGenerator.nextInt();
    if (z<0) z=-z;
    return z%x;
  }

}

class PasswordEntry extends Object {

	private String graph;
  private String [] spellings;
  private int type;

  public PasswordEntry(String g, int t, String [] s) {
  	graph = g;
    type = t;
    spellings = s;
  }
  public int getType() {
  	return type;
  }
  public String getLetters(int nbr) {
    return spellings[nbr];
  }
  public String getGraph() {
  	return graph;
  }
  public int getLettersCount() {
  	return spellings.length;
  }
}